// Mtodo da Secante
//
// encontra uma raiz no intervalo [xa,xb] da funo f(x)=x^3-9*x+3
//

deff('y=f(x)','y=x^3-9*x+3');        // funo f(x)
xa= 2.0;                             // valor inicial de xa
xb= 3.0;                             // valor inicial de xb
epsilon=0.000001;                    // tolerncia
Nmax=20;                             // nmero mximo de iteraes
i=0;                                 // contador

while (abs(xb-xa)>epsilon) & (i<Nmax)
  i=i+1;
  xm=(xa*f(xb)-xb*f(xa))/(f(xb)-f(xa));
  xa=xb;
  xb=xm;
end;

disp(xm)        // exibe o ltimo valor de xm calculado
disp(i)         // exibe o nmero de iteraes executadas
